// MaiFile.cpp: CMaiFile NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "direct.h"
#include "MaiFile.h"
#include "io.h"
#include "binfile.h"
#include "calcfile.h"
#include "idbfile.h"
#include "GlobalData.h"
#include "General.h"
#include "SelectRsu.h"
#include "SelectStartTimeDlg.h"
#include "MMA_G.h"
#include <math.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define	WORK_PATH		"\\temp"
#define	FN_DAT0	"data0.dat"
#define	FN_DAT1	"data1.dat"
#define	FN_DAT2	"data2.dat"
#define	FN_DAT3	"data3.dat"

static	int cmpfunc(const void *prm1, const void *prm2);
static	unsigned long GetMSecFromFileName(LPCSTR fname);

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CMaiFile::CMaiFile()
: m_maiFname(_T(""))
, m_WorkPath(_T(""))
, m_ConvDataPath(_T(""))
, m_CalcFile(NULL)
{
	CString	str;

	str = gRootPath;
	_mkdir((LPCSTR)str);
	str = gRootData;
	_mkdir((LPCSTR)str);

	m_WorkPath.Format("%s%s", gRootPath, WORK_PATH);	// t@C݃tH_
	_mkdir((LPCSTR)m_WorkPath);

	m_ConvDataPath = ".";
}

CMaiFile::~CMaiFile()
{

}

// Hwlf[^݃tH_쐬
int CMaiFile::mkDir(LPCSTR pos, LPCTSTR category, LPCTSTR measurement_kind)
{
	CString	str;
	str.Format("%s\\%s", gRootData, pos);
	// ʒutH_쐬
	_mkdir(str);

	// JeStH_쐬
	CString str1;
	str1.Format("%s\\%s", str, category);
	_mkdir(str1);

	// vރtH_쐬
	CString str2;
	str2.Format("%s\\%s", str1, measurement_kind);
	_mkdir(str2);

	CString	str3;
	str3.Format("%s\\%s", str2, m_maiFname);
	// mait@CtH_쐬
	if(_mkdir(str3)){
		if(errno == EEXIST){
			if(AfxMessageBox("̕ϊf[^͊ɑ݂܂B̂܂ܕϊsƁCf[^㏑܂B\nϊp܂H",MB_ICONQUESTION|MB_YESNO) == IDNO){
				return -1;
			}
		}
	}

	// Hwl݃tH_ۑ
	m_ConvDataPath = str3;

	return 0;
}

// f[^Zbg
void CMaiFile::ResetData(void)
{
	m_Name.RemoveAll();		// wtH_ɑ݂SĂmait@CۑGA
	m_Rsu.RemoveAll();	// mait@C̃ZTۑGA
	m_BinName0.RemoveAll();	// `lNo0BINt@CۑGA
	m_BinName1.RemoveAll();	// `lNo1BINt@CۑGA
	m_BinName2.RemoveAll();	// `lNo2BINt@CۑGA
	m_BinName3.RemoveAll();	// `lNo3BINt@CۑGA
	m_maiDat.RemoveAll();	// mait@C̓eSēǂݍރGA
	m_Samples0.RemoveAll();
	m_Samples1.RemoveAll();
	m_Samples2.RemoveAll();
	m_Samples3.RemoveAll();
}



// wtH_ɑ݂mait@CSĎ擾
int CMaiFile::GetMaiFileName(LPCSTR path)
{
	char wpath[MAX_PATH];
	struct _finddata_t c_file;
    intptr_t hFile;

	m_Name.RemoveAll();
	memset(wpath, 0, sizeof(wpath));
	strcpy_s(wpath, path);
	strcat_s(wpath, "\\*.mai");

    /* Jg fBNg̍ŏ .mai t@CT܂B*/
	if( (hFile = _findfirst(wpath, &c_file )) != -1L ) {
		m_Name.Add(c_file.name);
		/* c .mait@CT܂B */
		while( _findnext( hFile, &c_file ) == 0 ) {
			m_Name.Add(c_file.name);
		}
		_findclose( hFile );
	}
	return (int)m_Name.GetSize();
}

// update 2008/03/18 by hama@
// 擾mait@CZTNo擾
int CMaiFile::GetRsuFromMaiFileName(void)
{
	int	i, cnt;
	char buf[128], *token, *nexttoken;
	char *sep = "-_.";

	m_Rsu.RemoveAll();

	// mait@C擾
	if ((cnt = (int)m_Name.GetSize()) != 0) {
		// mait@C[v
		for (i = 0; i < cnt; i++) {
			strcpy_s(buf, (LPCSTR)m_Name.GetAt(i));
			// g[N擾
			if ((token = strtok_s( buf, sep, &nexttoken)) != NULL) {
				// ZTNo擾ς
				if (! IsRsu(token)) {
					// t@C̍ŏ̍ڂ擾
					m_Rsu.Add(token);
				}
			}
		}
	}
	return (int)m_Rsu.GetSize();
}

// ZTNo擾ς
bool CMaiFile::IsRsu(LPCSTR rsu)
{
	int	cnt = (int)m_Rsu.GetSize();
	int	i;

	for (i = 0; i < cnt; i++) {
		if (strcmp(rsu, (LPCSTR)m_Rsu.GetAt(i)) == 0)
			return true;
	}
	return false;
}
// update 2008/03/18 by hama@

// 擾mait@C̒MAX̐t@CT
bool CMaiFile::GetMaxMaiFileName(CString &fname, CString RsuNo)
{
	int	i, cnt, cntToken;
	unsigned long	l_max, value;	
	char buf[128], *token, *nexttoken, tokenDat[64];
	char *sep = "-_.";
	CString str = "";

	l_max = 0;
	// mait@C擾
	if ((cnt = (int)m_Name.GetSize()) == 0)
		return false;

	// mait@C[v
	for (i = 0; i < cnt; i++) {
		cntToken = 0;
		memset(tokenDat, 0, sizeof(tokenDat));
		strcpy_s(buf, (LPCSTR)m_Name.GetAt(i));
		// g[N擾
		token = strtok_s(buf, sep, &nexttoken);
// update 2008/03/18 by hama@
		if (strcmp(token, RsuNo) != 0)
			continue;
// update 2008/03/18 by hama@
		while (token != NULL) {
			cntToken++;
			// t@C̍Ō̍ڎ擾H
			if (cntToken > 8) {
				// t@C̍Ō̍ڂ̌ȍ~擾
				strcpy_s(tokenDat, token+4);
				value = (unsigned long)atoi(tokenDat);
				// MAXl
				if (l_max < value) {
					l_max = value;
					str = m_Name.GetAt(i);
				}
				break;
			}
			/* "string" Ƀg[NȂȂ܂ŌJԂ܂B */
			/* ̃g[N擾܂B */
			token = strtok_s( NULL, sep, &nexttoken );
		}
	}
	// MAXl擾łH
	if (l_max != 0) {
		fname = str;
		return true;
	}
	return false;
}

// mait@C̓eǂݍ
int CMaiFile::GetMaFileiData(LPCSTR path)
{
	CStdioFile	fp;
	CFileException fileException;

	m_maiDat.RemoveAll();

	if (! fp.Open(path, CFile::modeRead, &fileException)) {
		TRACE( "Can't open file %s, error = %u\n", path, fileException.m_cause );
		return 0;
	}

	CString	str;
	for(;;) {
		if (! fp.ReadString(str))
			break;
		m_maiDat.Add(str);
	}
	fp.Close();
	return (int)m_maiDat.GetSize();
}

// BINt@C0,1,2,3ɐU蕪
bool CMaiFile::FuriwakeBinFileName(void)
{
	int	i, chNo;
	int	cnt = (int)m_maiDat.GetSize();
	char *sep="File";
	char *sep2="Samples";
	CString	Files, Samples;
	long	sample;

	m_BinName0.RemoveAll();
	m_BinName1.RemoveAll();
	m_BinName2.RemoveAll();
	m_BinName3.RemoveAll();
	m_Samples0.RemoveAll();
	m_Samples1.RemoveAll();
	m_Samples2.RemoveAll();
	m_Samples3.RemoveAll();
	m_Total0 = 0;
	m_Total1 = 0;
	m_Total2 = 0;
	m_Total3 = 0;

	for (i = 0; i < cnt;) {
		// mait@Cf[^BINt@C擾
		if (GetDataFromMai(m_maiDat.GetAt(i), sep, Files) != false) {
			// BINt@C`lNo擾
			chNo = GetChNoFromFName((LPCSTR)Files);
			// `lNoɐU蕪
			switch(chNo) {
			case 0:
				// t@CZ[u
				m_BinName0.Add(Files);
				// t@CɊ܂܂Tv擾
				if (GetDataFromMai(m_maiDat.GetAt(i + 1), sep2, Samples) != false) {
					sample = atol((LPCSTR)Samples);
					m_Total0 += sample;
					m_Samples0.Add(sample);
					i++;
				}
				break;
			case 1:
				// t@CZ[u
				m_BinName1.Add(Files);
				// t@CɊ܂܂Tv擾
				if (GetDataFromMai(m_maiDat.GetAt(i + 1), sep2, Samples) != false) {
					sample = atol((LPCSTR)Samples);
					m_Total1 += sample;
					m_Samples1.Add(sample);
					i++;
				}
				break;
			case 2:
				// t@CZ[u
				m_BinName2.Add(Files);
				// t@CɊ܂܂Tv擾
				if (GetDataFromMai(m_maiDat.GetAt(i + 1), sep2, Samples) != false) {
					sample = atol((LPCSTR)Samples);
					m_Total2 += sample;
					m_Samples2.Add(sample);
					i++;
				}
				break;
			case 3:
				// t@CZ[u
				m_BinName3.Add(Files);
				// t@CɊ܂܂Tv擾
				if (GetDataFromMai(m_maiDat.GetAt(i + 1), sep2, Samples) != false) {
					sample = atol((LPCSTR)Samples);
					m_Total3 += sample;
					m_Samples3.Add(sample);
					i++;
				}
				break;
			}
		}
		i++;
	}

	return true;
}

// mait@Cf[^w荀ڂ擾
bool CMaiFile::GetDataFromMai(LPCSTR dat, LPCSTR itemStr, CString &oDat)
{
	char buf[128], *token, *nexttoken;
	char tokenDat[2][256];
	char *sep = "=\0";
	CString str = "";
	int	tokenCnt;

	memset(tokenDat, 0, sizeof(tokenDat));
	strcpy_s(buf, dat);
	tokenCnt = 0;
	// g[N擾
	token = strtok_s( buf, sep, &nexttoken);
	while (token != NULL) {
		strcpy_s(tokenDat[tokenCnt], token);
		tokenCnt++;
		if (tokenCnt > 1)
			break;
		token = strtok_s( NULL, sep, &nexttoken);
	}
	if (strcmp(itemStr, tokenDat[0]) != 0)
		return false;

	oDat = tokenDat[1];
	return true;
}

// BINt@C`lNo擾
int CMaiFile::GetChNoFromFName(LPCSTR fname)
{
	int	cntToken, rtNo;
	char buf[128], *token, *nexttoken, tokenDat[2][10];
	char *sep = "-";

	cntToken = 0;
	memset(tokenDat, 0, sizeof(tokenDat));
	strcpy_s(buf, fname);
	// g[N擾
	token = strtok_s( buf, sep, &nexttoken);
	while( token != NULL ) {
		strcpy_s(tokenDat[cntToken], token);
		cntToken++;
		if (cntToken > 1)
			break;
		/* "string" Ƀg[NȂȂ܂ŌJԂ܂B */
		/* ̃g[N擾܂B */
		token = strtok_s( NULL, sep, &nexttoken );
	}
	rtNo = atoi(tokenDat[1]);
	return rtNo;
}


// BINt@C̓t@C͍폜
int CMaiFile::DelSameName(void)
{
	int	arrcnt, i, j, isCnt;
	CString str;
	CStringArray *arr;
	CArray<long,long> *arr_l;

	for (arrcnt = 0; arrcnt < 4; arrcnt++) {
		switch(arrcnt) {
		case 0:
			arr = &m_BinName0;
			arr_l = &m_Samples0;
			break;
		case 1:
			arr = &m_BinName1;
			arr_l = &m_Samples1;
			break;
		case 2:
			arr = &m_BinName2;
			arr_l = &m_Samples2;
			break;
		case 3:
			arr = &m_BinName3;
			arr_l = &m_Samples3;
			break;
		}
		// 邩ׂ
		for (i = 0; i < arr->GetSize(); i++) {
			str = arr->GetAt(i);
			isCnt = 0;
			for (j = 0; j < arr->GetSize(); ) {
				if (str == arr->GetAt(j)) {
					// ꍇA폜
					if (isCnt != 0) {
						arr->RemoveAt(j);
						arr_l->RemoveAt(j);
						continue;
					} else {
						isCnt++;
					}
				}
				j++;
			}
		}
	}
	return 0;
}

// BINt@C\[g
void CMaiFile::SortArr(void)
{
	int	i, cnt, arrcnt;
	char (*p)[MAX_PATH];
	CStringArray *arr;

	for (arrcnt = 0; arrcnt < 4; arrcnt++) {
		switch(arrcnt) {
		case 0:
			arr = &m_BinName0;
			break;
		case 1:
			arr = &m_BinName1;
			break;
		case 2:
			arr = &m_BinName2;
			break;
		case 3:
			arr = &m_BinName3;
			break;
		}
		cnt = (int)arr->GetSize();
		p = new char[cnt][MAX_PATH];
		memset(p, 0, cnt * MAX_PATH);
		for (i = 0; i < cnt; i++) {
			strcpy_s(p[i], (LPCSTR)arr->GetAt(i));
		}
		qsort(p, cnt, MAX_PATH, cmpfunc);
		arr->RemoveAll();
		for (i = 0; i < cnt; i++) {
			arr->Add(p[i]);
		}
		delete [] p;
	}
}

// BINt@Cmb擾āA召r
static	int cmpfunc(const void *prm1, const void *prm2)
{
	unsigned long p1, p2;

	p1 = GetMSecFromFileName((LPCSTR)prm1);
	p2 = GetMSecFromFileName((LPCSTR)prm2);
	return p1 - p2;
}

// BINt@Cmb擾
static	unsigned long GetMSecFromFileName(LPCSTR fname)
{
	int	cntToken;
	char buf[128], *token, *nexttoken;
	char *sep = "-_.";
	unsigned long rt;

	rt = 0;
	cntToken = 0;
	strcpy_s(buf, fname);
	// g[N擾
	token = strtok_s( buf, sep, &nexttoken);
	while( token != NULL ) {
		cntToken++;
		// BINt@Cmb10ږ
		if (cntToken >= 10) {
			rt = (unsigned long)atol(token);
			break;
		}
		/* "string" Ƀg[NȂȂ܂ŌJԂ܂B */
		/* ̃g[N擾܂B */
		token = strtok_s( NULL, sep, &nexttoken );
	}
	return rt;
}

// f[^ČvZ
void CMaiFile::RecalcTotal(void)
{
	INT_PTR	i, cnt;

	m_Total0 = 0;
	m_Total1 = 0;
	m_Total2 = 0;
	m_Total3 = 0;

	cnt = m_Samples0.GetSize();
	for (i = 0; i < cnt; i++)
		m_Total0 += m_Samples0.GetAt(i);

	cnt = m_Samples1.GetSize();
	for (i = 0; i < cnt; i++)
		m_Total1 += m_Samples1.GetAt(i);

	cnt = m_Samples2.GetSize();
	for (i = 0; i < cnt; i++)
		m_Total2 += m_Samples2.GetAt(i);

	cnt = m_Samples3.GetSize();
	for (i = 0; i < cnt; i++)
		m_Total3 += m_Samples3.GetAt(i);
}

// X^[g^C擾
bool CMaiFile::GetStartTime(void)
{
	int	i;
	int	cnt = (int)m_maiDat.GetSize();
	char *sep="Start Time";
	CString	str;
	long YY, MM, DD, mS;
	bool	rt;

	rt = false;
	m_StartYY = 0;	// JnFN
	m_StartMM = 0;	// JnF
	m_StartDD = 0;	// JnF
	m_StartMS = 0;	// JnFmb

	for (i = 0; i < cnt; i++) {
		// mait@Cf[^X^[g^C擾
		if (GetDataFromMai(m_maiDat.GetAt(i), sep, str) != false) {
			// X^[g^C񂩂AYYMMDDmS擾
			if (GetStartYMDmS((LPCSTR)str, &YY, &MM, &DD, &mS) != false) {
				m_StartYY = YY;	// JnFN
				m_StartMM = MM;	// JnF
				m_StartDD = DD;	// JnF
				m_StartMS = mS;	// JnFmb
				rt = true;
				break;
			}
		}
	}

	return rt;
}

// X^[g^C񂩂AYYMMDDmS擾
bool CMaiFile::GetStartYMDmS(LPCSTR str, long * YY, long * MM, long * DD, long * mS)
{
	int	cntToken;
	char buf[128], *token, *nexttoken;
	char *sep = " ";

	cntToken = 0;
	strcpy_s(buf, str);
	// g[N擾
	token = strtok_s( buf, sep, &nexttoken);
	while( token != NULL ) {
		// BINt@Cmb10ږ
		switch(cntToken) {
		case 0:
			*YY = atol(token);
			break;
		case 1:
			*MM = atol(token);
			break;
		case 2:
			*DD = atol(token);
			break;
		case 3:
			*mS = atol(token);
			break;
		}
		cntToken++;
		/* "string" Ƀg[NȂȂ܂ŌJԂ܂B */
		/* ̃g[N擾܂B */
		token = strtok_s( NULL, sep, &nexttoken );
	}
	return (cntToken == 4);
}

// jbgID擾
bool CMaiFile::GetUnitID(void)
{
	int	i;
	int	cnt = (int)m_maiDat.GetSize();
	char *sep="Unit ID";
	CString	str;
	long	Unit;
	bool	rt;

	rt = false;
	m_RsuId = 0;

	for (i = 0; i < cnt; i++) {
		// mait@Cf[^烆jbgID擾
		if (GetDataFromMai(m_maiDat.GetAt(i), sep, str) != false) {
			// X^[g^C񂩂AYYMMDDmS擾
			Unit = strtol((LPCSTR)str, NULL, 0);
			m_RsuId = (Unit & 0xffff);
			m_NetworkId = ((Unit & 0xffff0000) >> 16);
			rt = true;
			break;
		}
	}
	return rt;
}

// ZT[ID擾
bool CMaiFile::GetSensorID(void)
{
	int	i;
	int	cnt = (int)m_maiDat.GetSize();
	char *sep="Sensor";
	CString	str;
	long	Sensor;
	bool	rt;

	rt = false;
	m_SensorId = 0;

	for (i = 0; i < cnt; i++) {
		// mait@Cf[^烆jbgID擾
		if (GetDataFromMai(m_maiDat.GetAt(i), sep, str) != false) {
			// X^[g^C񂩂AYYMMDDmS擾
			Sensor = strtol((LPCSTR)str, NULL, 0);
			m_SensorId = (Sensor & 0xffff);
			rt = true;
			break;
		}
	}
	return rt;
}

// Tv[g擾
bool CMaiFile::GetSampleRate(void)
{
	int	i;
	int	cnt = (int)m_maiDat.GetSize();
	char *sep="Data Sample Rate";
	CString	str;
	long	Rate;
	bool	rt;

	rt = false;
	m_SampleRate = 0;

	for (i = 0; i < cnt; i++) {
		// mait@Cf[^烆jbgID擾
		if (GetDataFromMai(m_maiDat.GetAt(i), sep, str) != false) {
			// X^[g^C񂩂AYYMMDDmS擾
			Rate = strtol((LPCSTR)str, NULL, 0);
			m_CntPerHour = Rate;
			m_SampleRate = (double)Rate / 60.0 / 60.0;
			rt = true;
			break;
		}
	}
	return rt;
}

// wpXmait@Cǂ݁AJnIZbg
int CMaiFile::ReadMaiFile(LPCSTR p_path, CDataDateTime * start, CDataDateTime * end)
{
	CString	path = p_path;
	CString	fname;
	CString	RsuNo;
	int	nRsu;

	// f[^Zbg
	ResetData();

	// mait@CSĎ擾
	if (GetMaiFileName(path) == 0) {
		CGeneral::Alert("_ENt@C݂܂B");
		return 0;
	}

	// 擾mait@CZTNo擾
	if ((nRsu = GetRsuFromMaiFileName()) == 0) {
		CGeneral::Alert("_ENt@C݂܂B");
		return 0;
	}

// update 2008/03/18 by hama@
	// ZT[ꍇ́AZT[Iʕ\
	if (nRsu > 1) {
		CSelectRsu	rsu;
		rsu.SetRsu(&m_Rsu);
		rsu.DoModal();
		rsu.GetRsu(RsuNo);
	} else {
		RsuNo = m_Rsu.GetAt(0);
	}
// update 2008/03/18 by hama@
/*
	// mait@C̓MAXl܂ރt@C擾
	if (! GetMaxMaiFileName(fname, RsuNo)) {
		CGeneral::Alert("_ENt@C݂܂B");
		return 0;
	}
*/
	// ̊Jnf[^݂ꍇ́AIʕ\
	{
		CSelectStartTimeDlg dlg;
		fname = dlg.GetMaiFileName(RsuNo, m_Name);
	}

	// mait@Cۑ
	m_maiFname = fname;

	//mait@Cf[^擾
	if (ReadMaiFile2(path + "\\" + fname, TRUE) == 0)
		return 0;

	// mait@Ceڂ擾
	if (!GetItems())
		return 0;

	// mait@C̊JnԂƃf[^玞Ԕ͈͎Zo
	GetStartEnd(start, end);

	return 1;
}

// mait@Ceڂ擾
BOOL CMaiFile::GetItems()
{
	// X^[g^C擾
	if (! GetStartTime()) {
		CGeneral::Alert("Jn擾ł܂B");
		return 0;
	}

	// jbgID擾
	if (! GetUnitID()) {
		CGeneral::Alert("UnitID擾ł܂B");
		return 0;
	}

	// ZT[ID擾
	if (! GetSensorID()) {
		CGeneral::Alert("SensorID擾ł܂B");
		return 0;
	}

	// Tv[g擾
	if (! GetSampleRate()) {
		CGeneral::Alert("DataSampleRate擾ł܂B");
		return 0;
	}

	return 1;
}

// mait@C̊JnԂƃf[^玞Ԕ͈͎擾
void CMaiFile::GetStartEnd(CDataDateTime *start, CDataDateTime *end)
{
	start->SetTime(m_StartYY, m_StartMM, m_StartDD, m_StartMS);
	*end = *start + (long)(m_Total0 / 4 * 40 / m_SampleRate * 1000);
}

// wmait@Cǂ
int CMaiFile::ReadMaiFile2(LPCSTR maiPath, BOOL bDispErrMsg)
{
	if (GetMaFileiData(maiPath) == 0) {
		if (bDispErrMsg)
			CGeneral::Alert("_ENt@C݂܂B");
		return 0;
	}

	// BINt@C0,1,2,3ɐU蕪
	FuriwakeBinFileName();

	// t@C͍폜
	DelSameName();

	// t@C\[g
	SortArr();

	// f[^ČvZ
	RecalcTotal();

	return 1;
}

// BINt@C̃wb_IDBɕۑ
void CMaiFile::GetBinInfo(LPCSTR fname)
{
	CBinFile binFile;
	if (binFile.OpenBin(fname)) {
		binFile.ReadHeader();
		binFile.CloseBin();
		// QCݒ
		m_Idb.SetGain((int)(pow(2.0, (double)(binFile.m_CalGain & 0x0f))));
		// JbgItg
		m_Idb.SetCutoff(binFile.m_CutOff);
		// BIASiTBD)
		m_Idb.SetBiascoeff(0);
		// XP[t@N^[iTBD)
		m_Idb.SetScalefactor(0);
		m_Cutofff = binFile.m_CutOff;	// JbgItg
		m_Offset = binFile.m_Offset;	// ItZbg
	}
}

// f[^o͂it@CHwlt@C܂Łj
BOOL CMaiFile::WriteData(LPCSTR p_path, long Start_msec, long End_msec)
{
	CProgressBar cProgressBar;
	BOOL	rt;

	m_path = p_path;		// ݃tH_pX
	m_Start_msec = Start_msec;
	m_End_msec = End_msec;

	m_CalcFile = new CCalcFile;

	// BINt@C̃wb_IDBɕۑ
	GetBinInfo(m_path+"\\"+m_BinName0.GetAt(0));

	// p[^n
	if (! m_CalcFile->SetArg(m_RsuId, m_SensorId, m_CntPerHour, m_Offset, m_Cutofff)) {
		delete m_CalcFile;
		CGeneral::Alert("Hwlϊp萔e[uɕs܂Bϊł܂B");
		return FALSE;
	}

	// vOXo[\AʃXbhŃt@Cǂݍ
	if (cProgressBar.ExecProcess("t@Cݒ", 10, this, WriteDataThread) == FALSE) {
		delete m_CalcFile;
		return FALSE;
	}

	// vOXo[\AʃXbhŃt@Cǂݍ
	rt = cProgressBar.ExecProcess("Hwlϊt@Cݒ", 10, this, WriteDataThread2);

	delete m_CalcFile;

	return rt;
}

BOOL CMaiFile::WriteDataThread(LPVOID pParam, CProgressBar* pProgressBar)
{
	return ((CMaiFile *)pParam)->WriteKetugouFile(pProgressBar);
}

BOOL CMaiFile::WriteDataThread2(LPVOID pParam, CProgressBar* pProgressBar)
{
	return ((CMaiFile *)pParam)->WriteCalcData(pProgressBar);
}

// w莞BINt@Cď
BOOL CMaiFile::WriteKetugouFile(CProgressBar* pProgressBar)
{
	CStdioFile dfp;
	CFileException f;
	int	i, j, nBin;
	long Cnt, Total, sa, WriteCnt, zan, from, PTotalCnt, PWCnt;
	CArray<long, long>*smpl;
	CStringArray	*arr;
	long startCnt, endCnt, sv_startCnt, sv_endCnt;
	CString path = m_path;
	CString	fname;

	// Jn̐擪̌AI̐擪̌Zo
	sv_startCnt = (long)(m_Start_msec * m_SampleRate / 1000);
	sv_endCnt = (long)(m_End_msec * m_SampleRate / 1000);
	PTotalCnt = (sv_endCnt - sv_startCnt) * 3 + (sv_endCnt - sv_startCnt) / 10;
	PWCnt = 0;

	// 0-3A4t@C[v
	for (i = 0; i < 4; i++) {
		switch(i) {
		case 0:
			startCnt = sv_startCnt / 10;
			endCnt = sv_endCnt / 10;
			arr = &m_BinName0;
			smpl = &m_Samples0;
			fname.Format("%s\\%s", m_WorkPath, FN_DAT0);
			break;
		case 1:
			startCnt = sv_startCnt;
			endCnt = sv_endCnt;
			arr = &m_BinName1;
			smpl = &m_Samples1;
			fname.Format("%s\\%s", m_WorkPath, FN_DAT1);
			break;
		case 2:
			startCnt = sv_startCnt;
			endCnt = sv_endCnt;
			arr = &m_BinName2;
			smpl = &m_Samples2;
			fname.Format("%s\\%s", m_WorkPath, FN_DAT2);
			break;
		case 3:
			startCnt = sv_startCnt;
			endCnt = sv_endCnt;
			arr = &m_BinName3;
			smpl = &m_Samples3;
			fname.Format("%s\\%s", m_WorkPath, FN_DAT3);
			break;
		}
		Total = 0;
		WriteCnt = 0;
		zan = endCnt - startCnt;
		// t@C1OPEN
		if (dfp.Open((LPCSTR)fname, CFile::modeCreate | CFile::modeWrite | CFile::typeBinary, &f)) {
			// JEg擾
			nBin = (int)smpl->GetSize();
			for (j = 0; j < nBin; j++) {
				// {t@Č擾
//				Cnt = smpl->GetAt(i);
				Cnt = smpl->GetAt(j);
				// Zo
				Total += Cnt;
				// ݐI傫ΏI
				if (WriteCnt >= endCnt)
					break;
				// f[^Jn菭ȂΎ
				if (Total < startCnt)
					continue;
				// ƊJnƂ̍߂
				sa = Total - startCnt;
				// {t@C荷傫ΑSď
				if (sa >= Cnt)
					from = 0;
				else
					from = Cnt - sa;

				CBinFile binFile;
				if (binFile.OpenBin(path+"\\"+arr->GetAt(j))) {
					int	cnt;
					cnt = binFile.WriteData(dfp, from, zan);
					WriteCnt += cnt;
					PWCnt += cnt;
					binFile.CloseBin();
				} else {
					CString	str;
					str.Format("f[^słB\nbint@C[%s]݂܂̂Œ~܂B", arr->GetAt(j));
					CGeneral::Alert(str);
					return FALSE;
				}
				zan = endCnt - WriteCnt;
				if (!pProgressBar->SetProgress(PWCnt * 10 / PTotalCnt)) {
					// f[^t@CN[Y
					dfp.Close();
					return FALSE;
				}
			}
			dfp.Close();
		}
	}
	return TRUE;
}

BOOL CMaiFile::WriteCalcData(CProgressBar* pProgressBar)
{
	int	i;
	long	msecCount, period;
	char	c;

	CString	fn0, fn1, fn2, fn3;
	fn0.Format("%s\\%s", m_WorkPath, FN_DAT0);
	fn1.Format("%s\\%s", m_WorkPath, FN_DAT1);
	fn2.Format("%s\\%s", m_WorkPath, FN_DAT2);
	fn3.Format("%s\\%s", m_WorkPath, FN_DAT3);

	CDataDateTime TimeZero, to;
	TimeZero = m_In_startTime;
	to = TimeZero;
	// f[^Ԕ͈͂Zoimsec)
	period = m_End_msec - m_Start_msec;

	// t@CHwlϊ1Ԗ̃t@Cɏ
	if (m_CalcFile->Open((LPCSTR)fn0, (LPCSTR)fn1, (LPCSTR)fn2, (LPCSTR)fn3)) {
		CString	str, str2, fullpath;
		// ԑ݂邩Zo
		int	nHour = period / 3600000 + ((period % 3600000) != 0);
		// ݂鎞Ԑ[v
		for (i = 0; i < nHour; i++) {
			msecCount = 0;
			if (period >= (i+1) * 3600000)
				msecCount = 3600000;
			else
				msecCount = (period - i * 3600000);
			// t@Ct@CҏW
			to += msecCount;
			if (i == 0) {
				// '-'}CiX
				c = '-';
			} else {
				// ȊO'+'vX
				c = '+';
			}
// 2008/5/13 modified by yG for sensor id format (decimal to hex) ->
//			str.Format("%04d_%02d_%02d_%02d_%02d_%02d.%03d%c%04d_%02d_%02d_%02d_%02d_%02d.%03d.%04d"
			str.Format("%04d_%02d_%02d_%02d_%02d_%02d.%03d%c%04d_%02d_%02d_%02d_%02d_%02d.%03d.%04x"
// <- 2008/5/13 modified by yG for sensor id format (decimal to hex)
				, TimeZero.m_YY
				, TimeZero.m_MM
				, TimeZero.m_DD
				, TimeZero.m_hh
				, TimeZero.m_mm
				, TimeZero.m_ss
				, TimeZero.m_ttt
				, c
				, to.m_YY
				, to.m_MM
				, to.m_DD
				, to.m_hh
				, to.m_mm
				, to.m_ss
				, to.m_ttt
				, m_SensorId);
//			str.Format("%04d%04d.dat", m_RsuId, i+1);
			str2 = str;

			fullpath.Format("%s\\%s", m_ConvDataPath, str);
			m_CalcFile->ReadOneHour();
			m_CalcFile->WriteOneHour((LPCSTR)fullpath, i + 1);

			m_Idb.AddFile((LPCSTR)str);
			// ^C[
			str.Format("%04d_%02d_%02d_%02d_%02d_%02d.%03d"
				, TimeZero.m_YY
				, TimeZero.m_MM
				, TimeZero.m_DD
				, TimeZero.m_hh
				, TimeZero.m_mm
				, TimeZero.m_ss
				, TimeZero.m_ttt);
			m_Idb.SetTimeZeroXML(str);
			m_Idb.WriteXml(str2, DATA_TYPE_MMA);
			TimeZero += 3600000;
			// vOXo[XV
			if (!pProgressBar->SetProgress((i + 1) * 10 / nHour)) {
				// f[^t@CN[Y
				m_CalcFile->Close();
				return FALSE;
			}
		}
		m_CalcFile->Close();
		str.Format("%04d%04d%02d%02d%d", m_RsuId, m_StartYY, m_StartMM, m_StartDD, m_StartMS);
		m_Idb.Write(str);
	}

	return TRUE;
}
